-- trashcan state machine

beginStateMachine()


	onEnter(function(msg)
		local fillLevel = retrieveData("fillLevel", 0.0);
		storeData("fillLevel", fillLevel);
		local stink = findChildGO("stink");
		stink.setEmitRate(0.0);
	end )


	onMsg("buildMenu", function(msg)
	
		if (repairMenu()) then return end
	
		-- build the pie menu
		clearPieMenu();
		
		local button = addPieMenuButton("pm_bringOutTrash", "takeTrash");
		button.addDescription(ACTIVITY, "takeTrash");
		button.addDescription(ACTIVITY, "improveTrashTidiness");
		button.addIcon("guiIconWohnung");

	end )

	-- 
	onMsg("takeTrash", function(msg)
		-- get the game object server
		local gameObjectServer = getGameObjectServer();
		-- get character who initiated this action
		local character = getStateObjectFromID(msg.sender);
		
		-- check if activity if possible
		local possible, result, activity = activityPossible(character, msg.name, this);
		
		-- don't care if timeslot is not fulfilled
		if (possible or enumCompare(result, TIMESLOT)) then
			-- walk to the closest action point
			local actionPoint = character.getClosestFreeActionPoint(character, this, {"take1", "take2", "take3", "take4",
			"take5", "take6", "take7", "take8"});
	
			if (actionPoint) then
				-- get the walk state object
				local wso = character.walkSO;
				local wsoContext = StateMachineContext();
				wsoContext.storeData("actionPointName", actionPoint.getName());
				if (wso.walkToActionPoint(actionPoint)) then
					wso.queueStateMachine("trashcanChar.takeTrash", this, wsoContext);
				else
					print("no path found");
					instantAbort(character, EMOTICON_NOPATH, "emoThink")
				end
			else
				print("no action point found");
				instantAbort(character, EMOTICON_CANNOT, "emoThink")
			end
		else
			-- activity not possible
			print(msg.name .. " not possible");
			
			local emoticon;
			if (enumCompare(result, NO_CONDITION)) then
				emoticon = conditionToEmoticon(activity.getUnfulfilledCondition());
			else
				emoticon = EMOTICON_CANNOT;
			end
			instantAbort(character, emoticon, "emoThink");
		end
	end )
			
			
endStateMachine()
